/* http://stackoverflow.com/questions/2442576/how-does-one-convert-16-bit-rgb565-to-24-bit-rgb888 */

#include <stdio.h>
#include <unistd.h>
#include <linux/types.h>

#define R 0xf800
#define G 0x07e0
#define B 0x001F
#define MBYTE 1048576

/* 0..31 -> 0..255: *8.226 =~ 527/64 */
/* 0..63 -> 0..255: *4.048 =~ 257/64 */

int main()
{
  __u16 inbuf[MBYTE];    /* 2 MByte == 1048576 Pixel */
  __u32 outbuf[MBYTE];   /* 4 Mbyte == 1048576 Pixel */
  int count, i;          /* I/O */
  __u16 *p;              /* wandert durch inbuf */
  unsigned char *rgba;   /* wandert durch outbuf */
  
  while (count = read(0, inbuf, MBYTE*sizeof(__u16)))    /* von Stdin lesen */
  {
    p = inbuf;
    rgba = (unsigned char *) outbuf;
    i = 0;
    while (i < count/sizeof(__u16))
    {
      rgba[0] = (*p & R) >> 11;  /* rot */
      rgba[0] *= 8.226;
      rgba[1] = (*p & G) >> 5;   /* gruen */
      rgba[1] *= 4.048;
      rgba[2] = *p & B;          /* blau */
      rgba[2] *= 8.226;
      rgba[3] = 0xff;            /* Transparenz */
      i++;
      p++;
      rgba += 4;
    }
    count = write(1, outbuf, i*sizeof(__u32));   /* nach Stdout schreiben */
  }
  return 0;
}
